
var MAIN_URL = "http://www.bittorrent.com/search_result.html?search=#TERM#&filterBy=#FILTER#&orderBy=#ORDER#&start_result=#SRESULT#";
var ROOT_URL = "http://www.bittorrent.com/";
var DEFAULT_TERM = "opera";
var ITEMS_PER_PAGE = 10; // This is to match what Bittorrent.com sends us and make according amount of tabs.
var ITEMS_MAX_CHARS = 30;
var VISIBLE_PAGE_TABS = 10;

function myProcessCallBack(feedItem) {
  if (feedItem.description.match(/&lt;/mgi) && feedItem.description.match(/&lt;/mgi).length > 1) {
    var tmp =  unescapeHTML(feedItem.description);
    tmp = tmp.replace(/<\/?td[^>]*>/img,"");
    tmp = tmp.replace(/<\/?tr[^>]*>/img,"");
    tmp = tmp.replace(/<\/?tbody[^>]*>/img,"");
    tmp = tmp.replace(/<\/?table[^>]*>/img,"");
    feedItem.description = tmp;
  }
  return feedItem;
}

function search() {
  document.getElementById("progress").style.visibility = "visible";
  var term = document.getElementById("term").value;
  var mySearch = new Feed();
  mySearch.url = addModifiers(MAIN_URL.replace(/#TERM#/,term));
  mySearch.feedReadyHandler = showResults;
  mySearch.feedMessageHandler = function() { }; // opera.postError;
  mySearch.feedErrorHandler = timedOut;
  mySearch.feedTimeOutHandler = timedOut;
  mySearch.itemize = itemize;
  mySearch.sendRequest();

  setSetting("term",term);
  return false;
}

function showResults(feed) {

  feed.title = feed.responseText.match(/<h2\s+id="resultsTitle">([\s\S]+)<\/h2>/mi)[1];
  document.getElementById("resultsTitle").innerHTML = feed.title;

  document.getElementById("progress").style.visibility = "hidden"; 

  var itemsDiv = document.getElementById("items"); 
  if(itemsDiv.hasChildNodes()) {
    itemsDiv.removeChild(itemsDiv.childNodes[0]);
  }

  var resultsInnerDiv = document.createElement("div");
  for(var i=0;i<feed.items.length;i++) {
    var truncatedTitle = truncate(feed.items[i].title.trim(),ITEMS_MAX_CHARS);
    var item = document.createElement("div");
    item.className = "item";
    item.innerHTML = "<span onclick='toggleItem("+i+")' class='itemTitle' id='item"+i+"' title="+feed.items[i].title+"><img src='images/dent.png' id='itemDent"+i+"' alt='>'>"+truncatedTitle+"</span>"+
    "<span class='itemDesc' id='itemDesc"+i+"'><a id='link"+i+"' href='"+feed.items[i].link+"'>Torrent letltse</a><br>"+feed.items[i].description+"</span>";
    resultsInnerDiv.appendChild(item);
  }
  itemsDiv.appendChild(resultsInnerDiv);


  for(var i=0;i<feed.items.length;i++) {
    var element = document.getElementById("item"+i);
    element.addEventListener(
      'mouseover', function (evt) {
//        opera.postError( 'over from: ' + evt.relatedTarget)
        var tooltip = document.getElementById("tooltip");
       if (evt.relatedTarget == tooltip) { return; } 
        mousein = true; 
        tooltip.style.left = (evt.pageX - 8 ) + 'px';
        tooltip.style.top  = (evt.pageY + 10 ) + 'px';
        var tooltipShadow = document.getElementById("tooltipShadow");
        tooltipShadow.style.left = (evt.pageX - 8 ) + 'px';
        tooltipShadow.style.top  = (evt.pageY + 10 ) + 'px';        
        starttooltip(evt.target);
      },false);
          
    element.addEventListener(
      'mouseout', function (evt) {
//        opera.postError('out to: ' + evt.relatedTarget)
        mousein = false;
        stoptooltip();
      }, false);
  }  
  
  document.getElementById("results").style.display = "block";
  if (feed.items.length) {
    var tSR = document.getElementById("toggleSearchResults");
    tSR.className = "minimizeGadget";
    tSR.onclick = "toggleResults();"
    tSR.style.cursor = "pointer";
    itemsDiv.style.display = "block";
  } else {
    itemsDiv.style.display = "none";
  }
  setSetting("curResults",feed.title.match(/(\d+)\s/mi)[1]);
  generatePageNav(getSetting("curResults"));
}

function generatePageNav(results) {
  // TODO: Fix so that it doesn't add a million pages...
  var pageNav = document.getElementById("pageNav");
  // remove existing elements
  while(pageNav.hasChildNodes()) {
    pageNav.removeChild(pageNav.childNodes[0]);
  }
   
  // if we have some results, let's make page tabs!
  if (results > 0) {
    var c=1;
    var curStartResult = (getSetting("startresult"))?parseInt(getSetting("startresult")):0;
    var start=0;
    var end=((results<(VISIBLE_PAGE_TABS*ITEMS_PER_PAGE))?results:VISIBLE_PAGE_TABS*ITEMS_PER_PAGE);
    pageNav.appendChild(document.createTextNode("Oldal: "));
    if (curStartResult >= end) {
      c = (curStartResult/ITEMS_PER_PAGE)+1;
      start += curStartResult;
      end = ((end + curStartResult)>results)?results:end + curStartResult;
      var moreEle = document.createElement("span");
      moreEle.innerHTML = "<< ";
      moreEle.className = "pageNavItem";
      moreEle.onclick = "goToPage("+(curStartResult-(VISIBLE_PAGE_TABS*ITEMS_PER_PAGE))+")";
      moreEle.title = (curStartResult-VISIBLE_PAGE_TABS);
      pageNav.appendChild(moreEle); 
    }
    
    if (curStartResult > 0) {
      var moreEle = document.createElement("span");
      moreEle.innerHTML = "< ";
      moreEle.className = "pageNavItem";
      moreEle.onclick = "goToPage("+((curStartResult-1)*VISIBLE_PAGE_TABS)+")";
      moreEle.title = ((curStartResult-1)*VISIBLE_PAGE_TABS);
      pageNav.appendChild(moreEle); 
    }

    for(var i=start;i<end;i+=ITEMS_PER_PAGE) {
      var temp = document.createElement("div");
      temp.className = "pageNavItem";
      if (curStartResult == i) {
        temp.className += " selPageNavItem";
      } else {
        temp.onclick = "goToPage("+i+")";
      }
      temp.id = "pageNavItem"+i;
      temp.title = i;
      temp.innerText = c;
      pageNav.appendChild(temp);
      c++;
    }
    
    if (results > ITEMS_PER_PAGE) {
      var moreEle = document.createElement("span");
      moreEle.innerHTML = " >";
      moreEle.className = "pageNavItem";
      moreEle.onclick = "goToPage("+((curStartResult+1)*VISIBLE_PAGE_TABS)+")";
      moreEle.title = curStartResult+1;
      pageNav.appendChild(moreEle);    
    }
    
    if (results > VISIBLE_PAGE_TABS*ITEMS_PER_PAGE+curStartResult){
      var moreEle = document.createElement("span");
      moreEle.innerHTML = " >>";
      moreEle.className = "pageNavItem";
      moreEle.onclick = "goToPage("+i+")";
      moreEle.title = i;
      pageNav.appendChild(moreEle);
    }
    
    pageNav.style.display = "block";

  } else {
    pageNav.style.display = "none";
  }
  repaint();
}

function toggleResults() {
  var itemsDiv = document.getElementById("itemsContainer");
  if (itemsDiv.currentStyle.display == "none") {
    itemsDiv.style.display = "block";
    document.getElementById("toggleSearchResults").className = "minimizeGadget";
  } else { 
    itemsDiv.style.display = "none";
    document.getElementById("toggleSearchResults").className = "maximizeGadget";    
  }
  repaint();
}

function itemize() {
  var tmpItems = this.responseText.match(/<li class="[^"]*hentry"[^>]*?>[\S\s]*?<\/li>/mgi);
 //  debug(tmpItems.length+" "+tmpItems);
  this.items = [];
  if (tmpItems) {
    for(var i=0;i<tmpItems.length;i++) {
      this.items[i] = {};
      this.items[i].outerHTML = tmpItems[i];
      this.items[i].title = (tmpItems[i].match(/<a[\S\s]*?rel="bookmark"[^>]*>([\S\s]*?)<\/a>/mi)[1]).replace(/<.*?>/mig,"");
      this.items[i].description = tmpItems[i].match(/(<div[^>]*?class="closedTri">[\s\S]*?</span></span>)/mi)[1];
      this.items[i].link = ROOT_URL+(tmpItems[i].match(/<a href="([^"]*?)">Download Torrent<\/a>/mi)[1]).replace(/^(\.\/)/,"").replace(/&amp;/,"&"); // ";
    }
  }
  return true;
}

function toggleItem(id) {
  var elem;
  var dent;
  if (elem = document.getElementById("itemDesc"+id)) {
    if (elem.style.display == "none" || !elem.style.display) {
      elem.style.display = "block";  
      if (dent = document.getElementById("itemDent"+id)) {
        dent.src = "images/dentopen.png";
      }
    } else {
      elem.style.display = "none";
      if (dent = document.getElementById("itemDent"+id)) {
        dent.src = "images/dent.png";
      }
    }
    repaint();
  }
}

function addModifiers(url)  {
  url = url.replace(/#ORDER#/,(getSetting("order")=="dall")?"":getSetting("order"));
  url = url.replace(/#FILTER#/,(getSetting("filter")=="mall")?"":getSetting("filter"));
  url = url.replace(/#SRESULT#/,(getSetting("startresult"))?getSetting("startresult"):0);
  return url;
}

function formSearch() {
  setSetting("startresult",0);
  setSetting("curResults",0);
  search();
}

function filterSearch(tag) {
  setFilter(tag);
  setSetting("startresult",0);  
  search();
}

function setFilter(tag) {
  var prevtag;
  if ((prevtag = getSetting("filter"))) {
    document.getElementById(prevtag).style.color = "#009900";
  }
  document.getElementById(tag).style.color = "black";
  setSetting("filter",tag);
}

function orderSearch(tag) {
  setOrder(tag);
  setSetting("startresult",0);  
  search();
}

function setOrder(tag) {
  var prevtag;
  if ((prevtag = getSetting("order"))) {
    document.getElementById(prevtag).style.color = "#009900";
  }
  document.getElementById(tag).style.color = "black";
  setSetting("order",tag);
}

function setStartResult(number) {
  setSetting("startresult",number);
}

function goToPage(number) {
  setStartResult(number);
  search();
}

function timedOut(feed) {
  var startResult = getSetting("startresult");
  feed.title = "<em>Search timed out with no results</em>";
  document.getElementById("progress").style.visibility = "hidden"; 
  var itemsDiv = document.getElementById("items"); 
  if(itemsDiv.hasChildNodes()) {
    itemsDiv.removeChild(itemsDiv.childNodes[0]);
  }
  if (!getSetting("curResults")) {
    document.getElementById("");
  }
  
  if (startResult) { 
    itemsDiv.innerHTML = feed.title;
  } else {  
    document.getElementById("resultsTitle").innerHTML = feed.title; 
  }  
  /*
  document.getElementById("items").style.display = "none";  */
  generatePageNav(getSetting("curResults"));
}

function isHandheld() {
  if (document.defaultView.getComputedStyle(document.getElementsByTagName("body")[0],'').getPropertyValue("background-color") == "#ffffff") { 
    return true;
  } else { 
    return false; 
  }
}

function isWidget() {
  if (widget) { return true; } else { return false; }
}

function main() {
  var term;
  if (term = getSetting("term")) {
    document.getElementById("term").value = term;
  } else {
    document.getElementById("term").value = DEFAULT_TERM;
  }
  setFilter(((getSetting("filter"))?getSetting("filter"):"mall"));
  setOrder(((getSetting("order"))?getSetting("order"):"dall"));  
  setSetting("curResults",0);
  setBackground();
  repaint();
}

function truncate(text,chars) {
  var ele = document.createElement("div");
  ele.innerHTML = text;
  text = ele.innerText;
  if (text.length > (chars-5)) {
    return text.substr(0,(chars-5))+" ... ";
  }
  return text;
}

function message(text) {
  debug(text);
  document.getElementById("messages").innerText = text;
}

function debug(text) {
  if (opera.postError) { opera.postError(text); } else { }
}

function starttooltip(ele) {
  stoptooltip();
  var tooltip = document.getElementById("tooltip");
  tooltip.innerHTML = ele.title.replace(/(.)/mgi,"$1&#x200B;");
  tooltip.style.display = "block";
  var tooltipShadow = document.getElementById("tooltipShadow");
  tooltipShadow.innerHTML = ele.title.replace(/(.)/mgi,"$1&#x200B;");;
  tooltipShadow.style.display = "block";
}

function stoptooltip() {
  var tooltip = document.getElementById("tooltip");
  tooltip.innerText = "";
  tooltip.style.display = "none";
  var tooltipShadow = document.getElementById("tooltipShadow");
  tooltipShadow.innerText = "";
  tooltipShadow.style.display = "none";
  
}

function setBackground() {
  var ele=document.getElementById("content");
  ele.createBGImage('images/gradient_box_shadow.png');
  ele.bgImage.setBorders(49);
  ele.bgImage.draw();
}

function repaint() {
  var ele=document.getElementById("content");
  ele.bgImage.draw();
  stoptooltip();
}

String.prototype.trim = function() { return this.replace(/^\s+|\s+$/, ''); };
